//==========================================================
// AUTHOR : mohan
// DATE : 2008-11-18
//==========================================================
#include "memory.h"

// 1024 bit  = 1 Byte
// 1024 Byte = 1 KB
// 1024 KB   = 1 MB
// 1024 MB   = 1 GB
double Memory::total = 0.0;
double Memory::complex_matrix_memory = 16.0;//(Byte)
double Memory::double_memory = 8.0;//(Byte)
double Memory::int_memory = 4.0;//(Byte)
double Memory::bool_memory = 1.0;//(Byte)
double Memory::float_memory = 4.0;//(Byte)
double Memory::short_memory = 2.0;//(Byte)

int Memory::n_memory = 500;
int Memory::n_now = 0;
bool Memory::init_flag =  false;

string *Memory::name;
string *Memory::class_name;
double *Memory::consume;

Memory::Memory()
{
}

Memory::~Memory()
{
}

double Memory::calculate_mem(const int &n_in,const string &type)
{
	double n = static_cast<double>(n_in);
	double mem = 0.0;
	
	double factor = 1.0/1024.0/1024.0;
	double complex_matrix_mem = complex_matrix_memory * factor;
	double double_mem = double_memory * factor;
	double int_mem = int_memory * factor;
	double bool_mem = bool_memory * factor;
	double float_mem = float_memory * factor;
	double short_mem = short_memory * factor;

	if(type=="ComplexMatrix" || type=="complexmatrix" || type=="cdouble")
	{
		mem = complex_matrix_mem;
	}
	else if(type=="real" || type=="double")
	{
		mem = double_mem;
	}
	else if(type=="int")
	{
		mem = int_mem;
	}
	else if(type=="bool")
	{
		mem = bool_mem;
	}
	else if(type=="short")
	{
		mem = short_mem;
	}
	else if(type=="float")
	{
		mem = float_mem;
	}
	else if(type=="AtomLink")
	{
		mem =  int_mem * 2 + double_mem * 3;
	}
	else if(type=="Vector3<double>")
	{
		mem = 3 * double_mem;
	}
	else
	{
		cout<<"not this type in memory storage : "<<type << endl;
	}
	total += n * mem;	
	return n*mem;
}
	

double Memory::record
(
 	const string &class_name_in,
	const string &name_in,
	const int &n_in,
	const string &type,
	const bool accumulate
)
{
	if(!Memory::init_flag)
	{
		name = new string[n_memory];
		class_name = new string[n_memory];
		consume = new double[n_memory];
		for(int i=0;i<n_memory;i++)
		{
			consume[i] = 0.0;
		}
		Memory::init_flag = true;
	}

	int find = 0;
	for(find = 0; find < n_now; find++)
	{
		if( name_in == name[find] )
		{
			break;
		}
	}

	// find == n_now : found a new record.	
	if(find == n_now)
	{
		n_now++;
		name[find] = name_in;
		class_name[find] = class_name_in;
	}
	if(n_now >= n_memory)
	{
		cout<<" Error! Too many memories required.";
		return 0.0;
	}

	consume[find] = Memory::calculate_mem(n_in,type);

	if(consume[find] > 5)
	{
		print(find);
	}
	return consume[find];
}

void Memory::print(const int find)
{
//	cout <<"\n Warning_Memory_Consuming : "
//	<<class_name[find]<<" "<<name[find]<<" "<<consume[find]<<" MB" << endl;
	return;
}


void Memory::finish(ofstream &ofs)
{
	print_all(ofs);
	if(init_flag)
	{
		delete[] name;
		delete[] class_name;
		delete[] consume;
		init_flag = false;
	}
	return;
}

void Memory::print_all(ofstream &ofs)
{
//	cout<<"\n init_flag="<<init_flag;
	if(!init_flag) return;

	const double small = 1.0; 
//    cout<<"\n CLASS_NAME---------|NAME---------------|MEMORY(MB)--------";
    ofs <<"\n CLASS_NAME---------|NAME---------------|MEMORY(MB)--------" << endl;
//	cout<<"\n"<<setw(41)<< " " <<setprecision(4)<<total;
	ofs <<setw(41)<< " " <<setprecision(4)<<total << endl;
    
	bool *print_flag = new bool[n_memory];
	for(int i=0; i<n_memory; i++) print_flag[i] = false;
	
	for (int i=0; i<n_memory; i++)
    {
		int k = 0;
		double tmp = -1.0;
		for(int j=0; j<n_memory; j++)
		{
			if(print_flag[j])
			{
				continue;
			}
			else if(tmp < consume[j])
			{
				k = j;
				tmp = consume[j];
			}
		}
		print_flag[k] = true;

	    if ( consume[k] < small ) 
        {
            continue;
        }
  		else
  		{
        	ofs  << " "
             << setw(20) << class_name[k]
             << setw(20) << name[k]
             << setw(15) << consume[k] << endl;

//        	cout  << "\n "
//             << setw(20) << class_name[k]
//             << setw(20) << name[k]
//             << setw(15) << consume[k];
		}
    }
//    cout<<"\n ----------------------------------------------------------"<<endl;
    ofs<<" ----------------------------------------------------------"<<endl;
	delete[] print_flag; //mohan fix by valgrind at 2012-04-02
	return;
}
