#ifndef GRID_BIGCELL_H
#define GRID_BIGCELL_H
#include "../src_pw/tools.h"
#include "grid_meshcell.h"

class Grid_BigCell: public Grid_MeshCell
{
	public:

	Grid_BigCell();
	~Grid_BigCell();

	// save the relative cartesian position
	// to bigcell of each atom.
	double** tau_in_bigcell;

	protected:

	//---------------------------------
	void init_big_latvec(void);

	double bigcell_vec1[3];
	double bigcell_vec2[3];
	double bigcell_vec3[3];

	Matrix3 bigcell_latvec0;
	Matrix3 bigcell_GT;
	//---------------------------------


	//---------------------------------
	void init_grid_expansion(const bool vna);

	// get the max radius of all orbitals.
	// which will use to generate grid expansion,
	// and  the meshball.
	double orbital_rmax;
	
	// Measure the distance between two bigcell
	// in each direction.
	double bigcell_dx;
	double bigcell_dy;
	double bigcell_dz;
	
	// the added number of bigcelli each direction.
	int dxe;
	int dye;
	int dze;

	// expansion grid dimension.
	int nxe;
	int nye;
	int nze;
	int nxyze;
	//---------------------------------


	//---------------------------------
	void init_tau_in_bigcell(void);

	//this flag will be false at first and turned to true after memory of tau_in_meshcell has been allocated.  
	bool flag_tib;

	int* index_atom;
	//---------------------------------


	//---------------------------------
	void grid_expansion_index(bool f2normal, int *target)const;
	//---------------------------------
};
#endif
