#ifndef TOWannier90_H
#define TOWannier90_H

#include <iostream>
using namespace std;
#include <vector>
#include <algorithm>
#include <cmath>
#include <cstdlib>
#include "src_pw/tools.h"
#include "src_global/lapack_connector.h"
#include "src_pw/global.h"
#include "src_pw/wavefunc_in_pw.h"
#include "src_lcao/local_orbital_wfc.h"


class toWannier90
{
public:
	//const int k_supercell = 5;                                                              // default the k-space supercell
	//const int k_cells = (2 * k_supercell + 1)*(2 * k_supercell + 1)*(2 * k_supercell + 1);  // the primitive cell number in k-space supercell
	//const int k_shells = 12;                                                                // default the shell numbers
	//const double large_number = 99999999.0;
	//const double small_number = 0.000001;
	//vector<Vector3<double>> lmn;                                                            //ÿkԭ
	//vector<double> dist_shell;                                                              //ÿһshellĽk
	//vector<int> multi;                                                                      //ÿһshellĽkĿ
	//int num_shell_real;                                                                     //B1shellĿս(ע1ʼ)
	//int *shell_list_real;                                                                   //112shellвƽвȼ۵shellǩΪnum_shell_real
	//double *bweight;                                                                        //ÿshellbweightΪnum_shell_real
	
	int num_kpts;                                                                           // kĿ
	int cal_num_kpts;                                                                       // ҪkĿnspin=2ʱô
	Matrix3 recip_lattice;
	vector<vector<int>> nnlist;                                                             //ÿkĽk
	vector<vector<Vector3<double>>> nncell;                                                 //ÿkĽkڵԭ
	int nntot = 0;                                                                          //ÿkĽkĿ   
	int num_wannier;																		//Ҫwannierĸ
	int *L;																					//̽Ľָ,Ϊnum_wannier
	int *m;																					//̽Ĵָ,Ϊnum_wannier
	int *rvalue;																			//̽ľ򲿷ֺʽ,ֻʽ,Ϊnum_wannier
	double *alfa;																			//̽ľ򲿷ֺеĵڲ,Ϊnum_wannier
	Vector3<double> *R_centre;																//̽,Ϊnum_wannier,cartesian
	string wannier_file_name = "seedname";                                                  // .mmn,.amnļ
	int num_exclude_bands = 0;																// ųܴĿ-1ʾûҪųܴ
	int *exclude_bands;                                                                     // ųܴindex
	bool *tag_cal_band;																		// жNBANDSܴһҪ
	int num_bands;																		   	// wannier90 еnum_bands
	bool gamma_only_wannier = false;														// ֻgammawannier
	string wannier_spin = "up";                                                             // spinup,down
	int start_k_index = 0;                                                                  // forѭѰkָ꣬spin=2ʱʼindexǲһ

	
	// lcaoµwannier90
	realArray table_local;
	ComplexMatrix *unk_inLcao;                                                             // lcao²ڲunk



	toWannier90(int num_kpts,Matrix3 recip_lattice);
	~toWannier90();

	//void kmesh_supercell_sort(); //ԭľСlmn
	//void get_nnkpt_first();      //12shellĽkľ͸
	//void kmesh_get_bvectors(int multi, int reference_kpt, double dist_shell, vector<Vector3<double>>& bvector);  //ȡָshell㣬ָοkĽkbvector
	//void get_nnkpt_last(); //ȡյshellĿbweight
    //void get_nnlistAndnncell();

	void init_wannier();
	void read_nnkp();
	void outEIG();
	void cal_Amn(const ComplexMatrix *wfc_pw);
	void cal_Mmn(const ComplexMatrix *wfc_pw);
	void produce_trial_in_pw(const int &ik, ComplexMatrix &trial_orbitals_k);
	void get_trial_orbitals_lm_k(const int wannier_index, const int orbital_L, const int orbital_m, matrix &ylm, 
										matrix &dr, matrix &r, matrix &psir, const int mesh_r, 
										Vector3<double> *gk, const int npw, ComplexMatrix &trial_orbitals_k);
	void integral(const int meshr, const double *psir, const double *r, const double *rab, const int &l, double* table);
	void writeUNK(const ComplexMatrix *wfc_pw);
	void ToRealSpace(const int &ik, const int &ib, const ComplexMatrix *evc, complex<double> *psir, const Vector3<double> G);
	complex<double> unkdotb(const complex<double> *psir, const int ikb, const int bandindex, const ComplexMatrix *wfc_pw);
	complex<double> unkdotkb(const int &ik, const int &ikb, const int &iband_L, const int &iband_R, const Vector3<double> G, const ComplexMatrix *wfc_pw);
	complex<double> gamma_only_cal(const int &ib_L, const int &ib_R, const ComplexMatrix *wfc_pw, const Vector3<double> G);
	
	// lcao
	void lcao2pw_basis(const int ik, ComplexMatrix &orbital_in_G);
	void getUnkFromLcao();
	void get_lcao_wfc_global_ik(complex<double> **ctot, complex<double> **cc);

};

#endif